#ifndef __MAKU_OBJECT_H__
#define __MAKU_OBJECT_H__

#include <glib.h>
#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

// related to object typecasting
#define MAKU_TYPE_OBJECT                 (maku_object_get_type())
#define MAKU_OBJECT(obj)                 (G_TYPE_CHECK_INSTANCE_CAST((obj), MAKU_TYPE_OBJECT, MakuObject))
#define MAKU_IS_OBJECT(obj)              (G_TYPE_CHECK_INSTANCE_TYPE((obj), MAKU_TYPE_OBJECT))

// related to object's klass typecasting
#define MAKU_OBJECT_CLASS(klass)         (G_TYPE_CHECK_CLASS_CAST((klass), MAKU_TYPE_OBJECT, MakuObjectClass))
#define MAKU_IS_OBJECT_CLASS(klass)      (G_TYPE_CHECK_CLASS_TYPE((klass), MAKU_TYPE_OBJECT))
#define MAKU_OBJECT_GET_CLASS(obj)       (G_TYPE_INSTANCE_GET_CLASS((obj), MAKU_TYPE_OBJECT, MakuObjectClass))


// forward declarations
typedef struct _MakuObject MakuObject;
typedef struct _MakuObjectClass MakuObjectClass;


enum {
 	SESSION_IDLE_CHANGED,
	LAST_SIGNAL
	};


// Object definition
struct _MakuObject
{
	GObject parent;
	gint age;
	DBusGProxy *gproxy;
};


// ObjectKlass definition
struct _MakuObjectClass
{
	GObjectClass parent;
	
	/* Signals */
};


// public methods
GType maku_object_get_type (void);
void maku_object_say_hello (MakuObject *object);
void maku_object_say_cheese (int i);



G_END_DECLS

#endif 		// __MAKU_OBJECT_H__

